# Row

## Method & Permission

| API        | GET                                              | POST                        | PUT | PATCH                           | DELETE |
| ---------- | ------------------------------------------------ | --------------------------- | --- | ------------------------------- | ------ |
| Row List   | Admin, Project Admin, Project Edit, Project View | Project Admin, Project Edit | -   | -                               | -      |
| Row Detail | Admin, Project Admin, Project Edit, Project View | -                           | -   | Project Admin\*, Project Edit\* | -      |

\*row with `is_locked=True` can not be updated

\*row with `is_archived=True` can not be updated, except the field of `is_archived`

## Row List

<mark style="color:blue;">`GET`</mark> `{{ base_url }} /tables/row/list/{level}/{sid}/{serializer}/`

#### Path Parameters

| Name       | Type   | Description      |
| ---------- | ------ | ---------------- |
| level      | string | organization     |
| sid        | string | organization sid |
| serializer | string |                  |

#### Query Parameters

| Name            | Type   | Description                                      |
| --------------- | ------ | ------------------------------------------------ |
| presigned\_post | string | Past presigned\_post to get URL to upload a file |

#### Headers

| Name  | Type   | Description |
| ----- | ------ | ----------- |
| token | string |             |

{% tabs %}
{% tab title="200 " %}

```yaml
# serializer = name
{
    "page_size": 10,
    "page_number": 1,
    "page_count": xxx,
    "count": xxx,
    "next": "xxx",
    "previous": null,
    "add_permission": true,
    "results": [
        {
            "sid": "xxx",
            "name": "EP625: Test Name 20200525133408",
            "table__name_plural": "experiments",
            "description": "Test add from sidebar 20200525133408"
        },
         ...
    ]
}
# serializer = list
{
    "page_size": 10,
    "page_number": 1,
    "page_count": xxx,
    "count": xxx,
    "next": "xxx",
    "previous": null,
    "add_permission": true,
    "results": [
        {
            "sid": "xxx",
            "uid": "EP622",
            "name": "EP622: Test Name 20200524151652",
            "column_set": [
                {
                    "column": {
                        "sid": "xxx",
                        "name": "date_start",
                        "name_system": null,
                        "description": "The start date of the expriment.",
                        "widget": {
                            "sid": "xxx",
                            "name": "Date",
                            "documentation_url": "https://docs.labii.com/widgets/column-widgets#date"
                        },
                        "default_value": null,
                        "order": 1,
                        "is_required": true,
                        "is_hidden": false,
                        "metadata": {
                            
                        },
                        "table": {
                            "sid": "xxx",
                            "name": "experiments"
                        },
                        "is_archived": false,
                        "date_created": "2020-02-10T03:02:26.988985Z",
                        "change_permission": false
                    },
                    "data": "2020-05-24",
                    "sid": "xxx"
                },
                {
                    "column": {
                        "sid": "xxx",
                        "name": "date_due",
                        "name_system": null,
                        "description": "The expected end date of the experiment.",
                        "widget": {
                            "sid": "xxx",
                            "name": "Date",
                            "documentation_url": "https://docs.labii.com/widgets/column-widgets#date"
                        },
                        "default_value": null,
                        "order": 2,
                        "is_required": false,
                        "is_hidden": false,
                        "metadata": {
                            
                        },
                        "table": {
                            "sid": "xxx",
                            "name": "experiments"
                        },
                        "is_archived": false,
                        "date_created": "2020-02-10T03:02:27.004055Z",
                        "change_permission": false
                    },
                    "data": ""
                }
            ],
            "projects": [
                {
                    "sid": "xxx",
                    "name": "Sample Project"
                }
            ],
            "owner": "Test Labii",
            "is_template": false,
            "change_permission": true
        },
         ...
    ]
}
# serializer = detail
{
    "page_size": 10,
    "page_number": 1,
    "page_count": xxx,
    "count": xxx,
    "next": "xxx",
    "previous": null,
    "add_permission": true,
    "results": [
        {
            "sid": "xxx",
            "uid": "EP622",
            "version": 3,
            "table": {
                "sid": "xxx",
                "name": "experiments"
            },
            "projects": [
                {
                    "sid": "xxx",
                    "name": "Sample Project"
                }
            ],
            "name": "EP622: Test Name 20200524151652",
            "description": "Test add from sidebar 20200524151652",
            "is_template": false,
            "is_archived": false,
            "metadata": [
                
            ],
            "updated_by": "Test Labii",
            "date_updated": "2020-05-24T22:19:35.179111Z",
            "owner": "Test Labii",
            "date_created": "2020-05-24T22:19:35.174584Z",
            "column_set": [
                {
                    "column": {
                        "sid": "xxx",
                        "name": "date_start",
                        "name_system": null,
                        "description": "The start date of the expriment.",
                        "widget": {
                            "sid": "xxx",
                            "name": "Date",
                            "documentation_url": "https://docs.labii.com/widgets/column-widgets#date"
                        },
                        "default_value": null,
                        "order": 1,
                        "is_required": true,
                        "is_hidden": false,
                        "metadata": {
                            
                        },
                        "table": {
                            "sid": "xxx",
                            "name": "experiments"
                        },
                        "is_archived": false,
                        "date_created": "2020-02-10T03:02:26.988985Z",
                        "change_permission": false
                    },
                    "data": "2020-05-24",
                    "sid": "xxx"
                },
                {
                    "column": {
                        "sid": "xxx",
                        "name": "date_due",
                        "name_system": null,
                        "description": "The expected end date of the experiment.",
                        "widget": {
                            "sid": "xxx",
                            "name": "Date",
                            "documentation_url": "https://docs.labii.com/widgets/column-widgets#date"
                        },
                        "default_value": null,
                        "order": 2,
                        "is_required": false,
                        "is_hidden": false,
                        "metadata": {
                            
                        },
                        "table": {
                            "sid": "xxx",
                            "name": "experiments"
                        },
                        "is_archived": false,
                        "date_created": "2020-02-10T03:02:27.004055Z",
                        "change_permission": false
                    },
                    "data": ""
                }
            ],
            "section_set": [
                {
                    "sid": "xxx",
                    "table": {
                        "sid": "xxx",
                        "name": "experiments"
                    },
                    "row": {
                        "sid": "xxx",
                        "name": "Overview"
                    },
                    "name": "Overview",
                    "description": "",
                    "widget": {
                        "sid": "xxx",
                        "icon": "format_color_text",
                        "name": "Rich Text (CKEditor Classic)",
                        "category": "Office",
                        "sub_category": "Text, Word, Docs",
                        "company": "Labii Inc.",
                        "notes": "Smart WYSIWYG HTML editor",
                        "description": "xxx",
                        "documentation_url": "https://docs.labii.com/widgets/office/text#rich-text-ckeditor-classic",
                        "usecase": "Protocol Steps; Experiment Overview; Descriptional Result;",
                        "type": "Section",
                        "constructor": "object",
                        "related_to": "xxx",
                        "version": "1.00",
                        "release_date": "2020-04-19",
                        "order": "2.00",
                        "subscription_price": "Free",
                        "ppu_price": "0.15",
                        "allow_multiple": true,
                        "is_readonly": false,
                        "metadata_labels": "",
                        "data": "xxx",
                        "default_data": ""
                    },
                    "data": {
                        
                    },
                    "order": 1,
                    "metadata": {
                        
                    },
                    "is_archived": false,
                    "date_updated": "2020-05-24T22:19:36.439669Z",
                    "date_created": "2020-05-24T22:19:36.436904Z",
                    "updated_by": "Test Labii",
                    "change_permission": true
                }
            ],
            "change_permission": true
        },
         ...
    ]
}
```

{% endtab %}

{% tab title="406 " %}

```
Error: missing table__sid in the get parameters
```

{% endtab %}
{% endtabs %}

## Row List

<mark style="color:green;">`POST`</mark> `{{ base_url }} /tables/row/list/{level}/{sid}/{serializer}/`

#### Path Parameters

| Name       | Type   | Description      |
| ---------- | ------ | ---------------- |
| level      | string | organization     |
| sid        | string | organization sid |
| serializer | string |                  |

#### Headers

| Name  | Type   | Description |
| ----- | ------ | ----------- |
| token | string |             |

#### Request Body

| Name                   | Type    | Description |
| ---------------------- | ------- | ----------- |
| projects               | array   |             |
| name                   | string  |             |
| description            | string  |             |
| is\_template           | boolean |             |
| open\_to\_organization | boolean |             |
| is\_archived           | boolean |             |
| metadata               | string  |             |

{% tabs %}
{% tab title="200 " %}

```yaml
{
    "sid": "xxx",
    "uid": "EP622",
    "version": 3,
    "table": {
        "sid": "xxx",
        "name": "experiments"
    },
    "projects": [
        {
            "sid": "xxx",
            "name": "Sample Project"
        }
    ],
    "name": "EP622: Test Name 20200524151652",
    "description": "Test add from sidebar 20200524151652",
    "is_template": false,
    "is_archived": false,
    "metadata": [
        
    ],
    "updated_by": "Test Labii",
    "date_updated": "2020-05-24T22:19:35.179111Z",
    "owner": "Test Labii",
    "date_created": "2020-05-24T22:19:35.174584Z",
    "column_set": [
        {
            "column": {
                "sid": "xxx",
                "name": "date_start",
                "name_system": null,
                "description": "The start date of the expriment.",
                "widget": {
                    "sid": "xxx",
                    "name": "Date",
                    "documentation_url": "https://docs.labii.com/widgets/column-widgets#date"
                },
                "default_value": null,
                "order": 1,
                "is_required": true,
                "is_hidden": false,
                "metadata": {
                    
                },
                "table": {
                    "sid": "xxx",
                    "name": "experiments"
                },
                "is_archived": false,
                "date_created": "2020-02-10T03:02:26.988985Z",
                "change_permission": false
            },
            "data": "2020-05-24",
            "sid": "xxx"
        },
        {
            "column": {
                "sid": "xxx",
                "name": "date_due",
                "name_system": null,
                "description": "The expected end date of the experiment.",
                "widget": {
                    "sid": "xxx",
                    "name": "Date",
                    "documentation_url": "https://docs.labii.com/widgets/column-widgets#date"
                },
                "default_value": null,
                "order": 2,
                "is_required": false,
                "is_hidden": false,
                "metadata": {
                    
                },
                "table": {
                    "sid": "xxx",
                    "name": "experiments"
                },
                "is_archived": false,
                "date_created": "2020-02-10T03:02:27.004055Z",
                "change_permission": false
            },
            "data": ""
        }
    ],
    "section_set": [
        {
            "sid": "xxx",
            "table": {
                "sid": "xxx",
                "name": "experiments"
            },
            "row": {
                "sid": "xxx",
                "name": "Overview"
            },
            "name": "Overview",
            "description": "",
            "widget": {
                "sid": "xxx",
                "icon": "format_color_text",
                "name": "Rich Text (CKEditor Classic)",
                "category": "Office",
                "sub_category": "Text, Word, Docs",
                "company": "Labii Inc.",
                "notes": "Smart WYSIWYG HTML editor",
                "description": "xxx",
                "documentation_url": "https://docs.labii.com/widgets/office/text#rich-text-ckeditor-classic",
                "usecase": "Protocol Steps; Experiment Overview; Descriptional Result;",
                "type": "Section",
                "constructor": "object",
                "related_to": "xxx",
                "version": "1.00",
                "release_date": "2020-04-19",
                "order": "2.00",
                "subscription_price": "Free",
                "ppu_price": "0.15",
                "allow_multiple": true,
                "is_readonly": false,
                "metadata_labels": "",
                "data": "xxx",
                "default_data": ""
            },
            "data": {
                
            },
            "order": 1,
            "metadata": {
                
            },
            "is_archived": false,
            "date_updated": "2020-05-24T22:19:36.439669Z",
            "date_created": "2020-05-24T22:19:36.436904Z",
            "updated_by": "Test Labii",
            "change_permission": true
        }
    ],
    "change_permission": true
},
}
```

{% endtab %}

{% tab title="406 " %}

```
Your organization does not have enough credits, contact sales@labii.com!
Character (%s) not allowed. Not allowed character are "#", "&", "*", "?", "^", "`", "<", ">"
```

{% endtab %}
{% endtabs %}

## Row Detail

<mark style="color:blue;">`GET`</mark> `{{ base_url }} /tables/row/detail/{sid}/`

#### Path Parameters

| Name | Type   | Description |
| ---- | ------ | ----------- |
| sid  | string |             |

#### Query Parameters

| Name            | Type   | Description                                         |
| --------------- | ------ | --------------------------------------------------- |
| presigned\_post | string | Pass presigned\_post to get URL to upload a file    |
| presigned\_url  | string | Pass presigned\_url to get URL to download the file |

#### Headers

| Name  | Type   | Description |
| ----- | ------ | ----------- |
| token | string |             |

{% tabs %}
{% tab title="200 " %}

```yaml
{
    "sid": "xxx",
    "uid": "EP622",
    "version": 3,
    "table": {
        "sid": "xxx",
        "name": "experiments"
    },
    "projects": [
        {
            "sid": "xxx",
            "name": "Sample Project"
        }
    ],
    "name": "EP622: Test Name 20200524151652",
    "description": "Test add from sidebar 20200524151652",
    "is_template": false,
    "is_archived": false,
    "metadata": [
        
    ],
    "updated_by": "Test Labii",
    "date_updated": "2020-05-24T22:19:35.179111Z",
    "owner": "Test Labii",
    "date_created": "2020-05-24T22:19:35.174584Z",
    "column_set": [
        {
            "column": {
                "sid": "xxx",
                "name": "date_start",
                "name_system": null,
                "description": "The start date of the expriment.",
                "widget": {
                    "sid": "xxx",
                    "name": "Date",
                    "documentation_url": "https://docs.labii.com/widgets/column-widgets#date"
                },
                "default_value": null,
                "order": 1,
                "is_required": true,
                "is_hidden": false,
                "metadata": {
                    
                },
                "table": {
                    "sid": "xxx",
                    "name": "experiments"
                },
                "is_archived": false,
                "date_created": "2020-02-10T03:02:26.988985Z",
                "change_permission": false
            },
            "data": "2020-05-24",
            "sid": "xxx"
        },
        {
            "column": {
                "sid": "xxx",
                "name": "date_due",
                "name_system": null,
                "description": "The expected end date of the experiment.",
                "widget": {
                    "sid": "xxx",
                    "name": "Date",
                    "documentation_url": "https://docs.labii.com/widgets/column-widgets#date"
                },
                "default_value": null,
                "order": 2,
                "is_required": false,
                "is_hidden": false,
                "metadata": {
                    
                },
                "table": {
                    "sid": "xxx",
                    "name": "experiments"
                },
                "is_archived": false,
                "date_created": "2020-02-10T03:02:27.004055Z",
                "change_permission": false
            },
            "data": ""
        }
    ],
    "section_set": [
        {
            "sid": "xxx",
            "table": {
                "sid": "xxx",
                "name": "experiments"
            },
            "row": {
                "sid": "xxx",
                "name": "Overview"
            },
            "name": "Overview",
            "description": "",
            "widget": {
                "sid": "xxx",
                "icon": "format_color_text",
                "name": "Rich Text (CKEditor Classic)",
                "category": "Office",
                "sub_category": "Text, Word, Docs",
                "company": "Labii Inc.",
                "notes": "Smart WYSIWYG HTML editor",
                "description": "xxx",
                "documentation_url": "https://docs.labii.com/widgets/office/text#rich-text-ckeditor-classic",
                "usecase": "Protocol Steps; Experiment Overview; Descriptional Result;",
                "type": "Section",
                "constructor": "object",
                "related_to": "xxx",
                "version": "1.00",
                "release_date": "2020-04-19",
                "order": "2.00",
                "subscription_price": "Free",
                "ppu_price": "0.15",
                "allow_multiple": true,
                "is_readonly": false,
                "metadata_labels": "",
                "data": "xxx",
                "default_data": ""
            },
            "data": {
                
            },
            "order": 1,
            "metadata": {
                
            },
            "is_archived": false,
            "date_updated": "2020-05-24T22:19:36.439669Z",
            "date_created": "2020-05-24T22:19:36.436904Z",
            "updated_by": "Test Labii",
            "change_permission": true
        }
    ],
    "change_permission": true
},
}
```

{% endtab %}
{% endtabs %}

## Row Detail

<mark style="color:purple;">`PATCH`</mark> `{{ base_url }} /tables/table/detail/{sid}/`

#### Path Parameters

| Name | Type   | Description |
| ---- | ------ | ----------- |
| sid  | string |             |

#### Headers

| Name  | Type   | Description |
| ----- | ------ | ----------- |
| token | string |             |

#### Request Body

| Name                   | Type   | Description |
| ---------------------- | ------ | ----------- |
| project\_\_sid         | string |             |
| name                   | string |             |
| description            | string |             |
| is\_template           | string |             |
| open\_to\_organization | string |             |
| is\_archived           | string |             |
| metadata               | string |             |

{% tabs %}
{% tab title="200 " %}

```yaml
{
    "sid": "xxx",
    "uid": "EP622",
    "version": 3,
    "table": {
        "sid": "xxx",
        "name": "experiments"
    },
    "projects": [
        {
            "sid": "xxx",
            "name": "Sample Project"
        }
    ],
    "name": "EP622: Test Name 20200524151652",
    "description": "Test add from sidebar 20200524151652",
    "is_template": false,
    "is_archived": false,
    "metadata": [
        
    ],
    "updated_by": "Test Labii",
    "date_updated": "2020-05-24T22:19:35.179111Z",
    "owner": "Test Labii",
    "date_created": "2020-05-24T22:19:35.174584Z",
    "column_set": [
        {
            "column": {
                "sid": "xxx",
                "name": "date_start",
                "name_system": null,
                "description": "The start date of the expriment.",
                "widget": {
                    "sid": "xxx",
                    "name": "Date",
                    "documentation_url": "https://docs.labii.com/widgets/column-widgets#date"
                },
                "default_value": null,
                "order": 1,
                "is_required": true,
                "is_hidden": false,
                "metadata": {
                    
                },
                "table": {
                    "sid": "xxx",
                    "name": "experiments"
                },
                "is_archived": false,
                "date_created": "2020-02-10T03:02:26.988985Z",
                "change_permission": false
            },
            "data": "2020-05-24",
            "sid": "xxx"
        },
        {
            "column": {
                "sid": "xxx",
                "name": "date_due",
                "name_system": null,
                "description": "The expected end date of the experiment.",
                "widget": {
                    "sid": "xxx",
                    "name": "Date",
                    "documentation_url": "https://docs.labii.com/widgets/column-widgets#date"
                },
                "default_value": null,
                "order": 2,
                "is_required": false,
                "is_hidden": false,
                "metadata": {
                    
                },
                "table": {
                    "sid": "xxx",
                    "name": "experiments"
                },
                "is_archived": false,
                "date_created": "2020-02-10T03:02:27.004055Z",
                "change_permission": false
            },
            "data": ""
        }
    ],
    "section_set": [
        {
            "sid": "xxx",
            "table": {
                "sid": "xxx",
                "name": "experiments"
            },
            "row": {
                "sid": "xxx",
                "name": "Overview"
            },
            "name": "Overview",
            "description": "",
            "widget": {
                "sid": "xxx",
                "icon": "format_color_text",
                "name": "Rich Text (CKEditor Classic)",
                "category": "Office",
                "sub_category": "Text, Word, Docs",
                "company": "Labii Inc.",
                "notes": "Smart WYSIWYG HTML editor",
                "description": "xxx",
                "documentation_url": "https://docs.labii.com/widgets/office/text#rich-text-ckeditor-classic",
                "usecase": "Protocol Steps; Experiment Overview; Descriptional Result;",
                "type": "Section",
                "constructor": "object",
                "related_to": "xxx",
                "version": "1.00",
                "release_date": "2020-04-19",
                "order": "2.00",
                "subscription_price": "Free",
                "ppu_price": "0.15",
                "allow_multiple": true,
                "is_readonly": false,
                "metadata_labels": "",
                "data": "xxx",
                "default_data": ""
            },
            "data": {
                
            },
            "order": 1,
            "metadata": {
                
            },
            "is_archived": false,
            "date_updated": "2020-05-24T22:19:36.439669Z",
            "date_created": "2020-05-24T22:19:36.436904Z",
            "updated_by": "Test Labii",
            "change_permission": true
        }
    ],
    "change_permission": true
},
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.labii.com/api/methods/row.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
